## sundials 2.7.0+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4958 $
# $Date: 2016-09-23 14:02:13 -0700 (Fri, 23 Sep 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)


# -------------------------------------------------------------
# Initial commands
# -------------------------------------------------------------

# Require a fairly recent cmake version

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.1)

# Set CMake policy to allow examples to build
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Project SUNDIALS (initially only C supported)

PROJECT(sundials C)

# Set some variables with info on the SUNDIALS project

SET(PACKAGE_BUGREPORT "woodward6@llnl.gov")
SET(PACKAGE_NAME "SUNDIALS")
SET(PACKAGE_STRING "SUNDIALS 2.7.0")
SET(PACKAGE_TARNAME "sundials")
SET(PACKAGE_VERSION "2.7.0")

# 
SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

# Prohibit in-source build

IF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  MESSAGE(FATAL_ERROR "In-source build prohibited.")
ENDIF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Hide/show some cache variables

MARK_AS_ADVANCED(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)
MARK_AS_ADVANCED(CLEAR
  CMAKE_C_COMPILER
  CMAKE_C_FLAGS
  CMAKE_C_FLAGS_DEBUG
  CMAKE_C_FLAGS_MINSIZEREL
  CMAKE_C_FLAGS_RELEASE
  CMAKE_C_FLAGS_RELWITHDEB)

# Specify the VERSION and SOVERSION for shared libraries

SET(arkodelib_VERSION "1.1.0")
SET(arkodelib_SOVERSION "1")

SET(cvodelib_VERSION "2.9.0")
SET(cvodelib_SOVERSION "2")

SET(cvodeslib_VERSION "2.9.0")
SET(cvodeslib_SOVERSION "2")

SET(idalib_VERSION "2.9.0")
SET(idalib_SOVERSION "2")

SET(idaslib_VERSION "1.3.0")
SET(idaslib_SOVERSION "1")

SET(kinsollib_VERSION "2.9.0")
SET(kinsollib_SOVERSION "2")

SET(cpodeslib_VERSION "0.0.0")
SET(cpodeslib_SOVERSION "0")

SET(nveclib_VERSION "2.7.0")
SET(nveclib_SOVERSION "2")

# Specify the location of additional CMAKE modules

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/config)

# -------------------------------------------------------------
# MACRO definitions
# -------------------------------------------------------------

# Macros to hide/show cached variables.
# These two macros can be used to "hide" or "show" in the
# list of cached variables various variables and/or options 
# that depend on other options.
# Note that once a variable is modified, it will preserve its
# value (hidding it merely makes it internal)

MACRO(HIDE_VARIABLE var)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE INTERNAL "")
  ENDIF(DEFINED ${var})
ENDMACRO(HIDE_VARIABLE)

MACRO(SHOW_VARIABLE var type doc default)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE "${type}" "${doc}" FORCE)
  ELSE(DEFINED ${var})
    SET(${var} "${default}" CACHE "${type}" "${doc}")
  ENDIF(DEFINED ${var})
ENDMACRO(SHOW_VARIABLE)

# Macros to append a common suffix or prefix to the elements of a list

MACRO(ADD_SUFFIX rootlist suffix)
  SET(outlist )
  FOREACH(root ${${rootlist}})
    LIST(APPEND outlist ${root}${suffix})
  ENDFOREACH(root)
  SET(${rootlist} ${outlist})
ENDMACRO(ADD_SUFFIX)

MACRO(ADD_PREFIX prefix rootlist)
  SET(outlist )
  FOREACH(root ${${rootlist}})
    LIST(APPEND outlist ${prefix}${root})
  ENDFOREACH(root)
  SET(${rootlist} ${outlist})
ENDMACRO(ADD_PREFIX)

# Macro to print warning that some features will be disabled
# due to some failure.

MACRO(PRINT_WARNING message action)
  MESSAGE("WARNING: ${message}.\n   ${action}.")
ENDMACRO(PRINT_WARNING)

# Returns an unquoted string.  Note that CMake will readily turn such
# strings back into lists, due to the duality of lists and
# semicolon-separated strings.  So be careful how you use it.

MACRO(LIST2STRING alist astring)
  FOREACH(elem ${${alist}})
   SET(${astring} "${${astring}} ${elem}")
  ENDFOREACH(elem)
ENDMACRO(LIST2STRING)

# -------------------------------------------------------------
# Which modules to build?
# -------------------------------------------------------------

# For each SUNDIALS solver available (i.e. for which we have the
# sources), give the user the option of enabling/disabling it.

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")
  OPTION(BUILD_ARKODE  "Build the ARKODE library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")
  SET(BUILD_ARKODE OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")
  OPTION(BUILD_CVODE  "Build the CVODE library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")
  SET(BUILD_CVODE OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")
  OPTION(BUILD_CVODES  "Build the CVODES library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")
  SET(BUILD_CVODES OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")
  OPTION(BUILD_IDA  "Build the IDA library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")
  SET(BUILD_IDA OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")
  OPTION(BUILD_IDAS  "Build the IDAS library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")
  SET(BUILD_IDAS OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")
  OPTION(BUILD_KINSOL  "Build the KINSOL library"  ON)
ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")
  SET(BUILD_KINSOL OFF)
ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")

# CPODES is always OFF for now.  (commented out for Release); ToDo: better way to do this?
#IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")
#  OPTION(BUILD_CPODES  "Build the CPODES library"  OFF)
#ELSE(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")
#  SET(BUILD_CPODES OFF)
#ENDIF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")

# -------------------------------------------------------------
# Other configuration options
# -------------------------------------------------------------

# Option that allows users to build static and/or shared libraries
# ----------------------------------------------------------------

OPTION(BUILD_STATIC_LIBS "Build static libraries" ON)
OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Prepare substitution variable SUNDIALS_EXPORT for sundials_config.h
# When building shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllexport)
# When linking to shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllimport)
# In all other cases (other platforms or static libraries
# under Windows), the SUNDIALS_EXPORT macro is empty

IF(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT
    "#ifdef BUILD_SUNDIALS_LIBRARY
#define SUNDIALS_EXPORT __declspec(dllexport)
#else
#define SUNDIALS_EXPORT __declspec(dllimport)
#endif")
ELSE(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT "#define SUNDIALS_EXPORT")
ENDIF(BUILD_SHARED_LIBS AND WIN32)

# Make sure we build at least one type of libraries
IF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
  PRINT_WARNING("Both static and shared library generation were disabled"
    "Building static libraries was re-enabled")
  SET(BUILD_STATIC_LIBS ON CACHE BOOL "Build static libraries" FORCE)
ENDIF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)

# Option to specify precision
# ---------------------------

SET(SUNDIALS_PRECISION "double" CACHE STRING "double, single or extended")

# prepare substitution variable PRECISION_LEVEL for sundials_config.h
STRING(TOUPPER ${SUNDIALS_PRECISION} SUNDIALS_PRECISION)
SET(PRECISION_LEVEL "#define SUNDIALS_${SUNDIALS_PRECISION}_PRECISION 1")

# Option to use the generic math libraries (UNIX only)
# ----------------------------------------------------

IF(UNIX)
  OPTION(USE_GENERIC_MATH "Use generic (std-c) math libraries" ON)
  IF(USE_GENERIC_MATH)
    # executables will be linked against -lm 
    SET(EXTRA_LINK_LIBS -lm)
    # prepare substitution variable for sundials_config.h
    SET(SUNDIALS_USE_GENERIC_MATH TRUE)
  ENDIF(USE_GENERIC_MATH)
ENDIF(UNIX)

## clock-monotonic, see if we need to link with rt
include(CheckSymbolExists)
set(CMAKE_REQUIRED_LIBRARIES_SAVE ${CMAKE_REQUIRED_LIBRARIES})
set(CMAKE_REQUIRED_LIBRARIES rt)
CHECK_SYMBOL_EXISTS(_POSIX_TIMERS "unistd.h;time.h" SUNDIALS_POSIX_TIMERS)
set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES_SAVE})
if(SUNDIALS_POSIX_TIMERS)
  find_library(SUNDIALS_RT_LIBRARY NAMES rt)
  mark_as_advanced(SUNDIALS_RT_LIBRARY)
  if(SUNDIALS_RT_LIBRARY)
    # sundials_config.h symbol
    SET(SUNDIALS_HAVE_POSIX_TIMERS TRUE)
    set(EXTRA_LINK_LIBS ${EXTRA_LINK_LIBS} ${SUNDIALS_RT_LIBRARY})
  endif()
endif()

# -------------------------------------------------------------
# Enable Fortran support?
# -------------------------------------------------------------

# FCMIX support is an option only if at least one solver that 
# provides such an interface is built.

IF(BUILD_ARKODE OR BUILD_CVODE OR BUILD_IDA OR BUILD_KINSOL)
  SHOW_VARIABLE(FCMIX_ENABLE BOOL "Enable Fortran-C support" OFF)
ELSE(BUILD_ARKODE OR BUILD_CVODE OR BUILD_IDA OR BUILD_KINSOL)
  HIDE_VARIABLE(FCMIX_ENABLE)
ENDIF(BUILD_ARKODE OR BUILD_CVODE OR BUILD_IDA OR BUILD_KINSOL)

# -------------------------------------------------------------
# Enable Fortran90 support?
# -------------------------------------------------------------

# F90 support is an option only if ARKode is built and 
# examples are enabled

IF(BUILD_ARKODE AND EXAMPLES_ENABLE AND FCMIX_ENABLE)
  SHOW_VARIABLE(F90_ENABLE BOOL "Enable Fortran90 ARKode examples" OFF)
ELSE(BUILD_ARKODE AND EXAMPLES_ENABLE AND FCMIX_ENABLE)
  # # set back to OFF (in case was ON)
  # SET(F90_ENABLE OFF)
  # HIDE_VARIABLE(F90_ENABLE AND FCMIX_ENABLE)
  HIDE_VARIABLE(F90_ENABLE)
ENDIF(BUILD_ARKODE AND EXAMPLES_ENABLE AND FCMIX_ENABLE)

# -------------------------------------------------------------
# Enable C++ support?
# -------------------------------------------------------------

# C++ support is an option only if ARKode is built and 
# examples are enabled

IF(BUILD_ARKODE AND EXAMPLES_ENABLE)
  SHOW_VARIABLE(CXX_ENABLE BOOL "Enable C++ ARKode examples" OFF)
ELSE(BUILD_ARKODE AND EXAMPLES_ENABLE)
  HIDE_VARIABLE(CXX_ENABLE)
ENDIF(BUILD_ARKODE AND EXAMPLES_ENABLE)

# -------------------------------------------------------------
# Enable BLAS/LAPACK support?
# -------------------------------------------------------------

OPTION(LAPACK_ENABLE "Enable Lapack support" OFF)

IF(NOT LAPACK_ENABLE)
  HIDE_VARIABLE(SUNDIALS_F77_FUNC_CASE)
  HIDE_VARIABLE(SUNDIALS_F77_FUNC_UNDERSCORES)
  HIDE_VARIABLE(LAPACK_LIBRARIES)
ENDIF(NOT LAPACK_ENABLE)

# -------------------------------------------------------------
# Enable SUPERLUMT support?
# -------------------------------------------------------------

OPTION(SUPERLUMT_ENABLE "Enable SUPERLUMT support" OFF)

IF(NOT SUPERLUMT_ENABLE)
  HIDE_VARIABLE(SUPERLUMT_THREAD_TYPE)
  HIDE_VARIABLE(SUPERLUMT_LIBRARY_DIR)
  HIDE_VARIABLE(SUPERLUMT_INCLUDE_DIR)
  SET (SUPERLUMT_DISABLED TRUE CACHE INTERNAL "GUI - return when first set")
ENDIF(NOT SUPERLUMT_ENABLE)

# -------------------------------------------------------------
# Enable KLU support?
# -------------------------------------------------------------

=== src/cvode/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4759 $
# $Date: 2016-05-18 16:25:17 -0700 (Wed, 18 May 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the CVODE library

INSTALL(CODE "MESSAGE(\"\nInstall CVODE\n\")")

IF(MPI_MPICC)
  # use MPI_MPICC as the compiler
  SET(CMAKE_C_COMPILER ${MPI_MPICC})
ELSE(MPI_MPICC)
  # add MPI_INCLUDE_PATH to include directories
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(MPI_MPICC)

# Add variable cvode_SOURCES with the sources for the CVODE library
SET(cvode_SOURCES
  cvode.c
  cvode_io.c
  cvode_direct.c        
  cvode_band.c
  cvode_dense.c
  cvode_diag.c
  cvode_spils.c
  cvode_spbcgs.c
  cvode_spgmr.c
  cvode_sptfqmr.c
  cvode_sparse.c
  cvode_bandpre.c
  cvode_bbdpre.c
  )

IF(KLU_FOUND)
    LIST(APPEND cvode_SOURCES cvode_klu.c)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND cvode_SOURCES cvode_superlumt.c)
ENDIF()

# IF(HYPRE_FOUND)
#      LIST(APPEND cvode_SOURCES cvode_hypamgpre.c)
# ENDIF()

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the CVODE library
SET(shared_SOURCES
  sundials_nvector.c
  sundials_math.c
  sundials_direct.c
  sundials_band.c
  sundials_dense.c
  sundials_iterative.c
  sundials_sparse.c
  sundials_spbcgs.c
  sundials_spgmr.c
  sundials_sptfqmr.c
  )

# Add prefix with complete path to the common SUNDIALS sources
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable cvode_HEADERS with the exported CVODE header files
SET(cvode_HEADERS
  cvode_band.h
  cvode_bandpre.h
  cvode_bbdpre.h
  cvode_dense.h
  cvode_diag.h
  cvode_direct.h
  cvode.h
  cvode_sparse.h
  cvode_spbcgs.h
  cvode_spgmr.h
  cvode_spils.h
  cvode_sptfqmr.h
  )

IF(KLU_FOUND)
    LIST(APPEND cvode_HEADERS cvode_klu.h)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND cvode_HEADERS cvode_superlumt.h)
ENDIF()

# IF(HYPRE_FOUND)
#      LIST(APPEND cvode_HEADERS cvode_hypamgpre.h)
# ENDIF()

# Add prefix with complete path to the CVODE header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/cvode/ cvode_HEADERS)

# If Blas/Lapack support was enabled, set-up additional file lists
IF(LAPACK_FOUND)
  SET(cvode_BL_SOURCES cvode_lapack.c)
  SET(cvode_BL_HEADERS cvode_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/cvode/ cvode_BL_HEADERS)
ELSE(LAPACK_FOUND)
  SET(cvode_BL_SOURCES "")
  SET(cvode_BL_HEADERS "")
ENDIF(LAPACK_FOUND)

# Add source directories to include directories for access to
# implementation only header files.
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(../sundials)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Build the static library
IF(BUILD_STATIC_LIBS)

  # Add the build target for the static CVODE library
  ADD_LIBRARY(sundials_cvode_static STATIC 
    ${cvode_SOURCES}  ${cvode_BL_SOURCES} ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_cvode_static
    PROPERTIES OUTPUT_NAME sundials_cvode CLEAN_DIRECT_OUTPUT 1)

  # Install the CVODE library
  INSTALL(TARGETS sundials_cvode_static DESTINATION lib)

ENDIF(BUILD_STATIC_LIBS)

# Build the shared library
IF(BUILD_SHARED_LIBS)

  # Add the build target for the CVODE library
  ADD_LIBRARY(sundials_cvode_shared SHARED 
    ${cvode_SOURCES}  ${cvode_BL_SOURCES}  ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_cvode_shared
    PROPERTIES OUTPUT_NAME sundials_cvode CLEAN_DIRECT_OUTPUT 1)

  # Set VERSION and SOVERSION for shared libraries
  SET_TARGET_PROPERTIES(sundials_cvode_shared
    PROPERTIES VERSION ${cvodelib_VERSION} SOVERSION ${cvodelib_SOVERSION})

  # Install the CVODE library
  INSTALL(TARGETS sundials_cvode_shared DESTINATION lib)

ENDIF(BUILD_SHARED_LIBS)

# Install the CVODE header files
INSTALL(FILES ${cvode_HEADERS} ${cvode_BL_HEADERS} DESTINATION include/cvode)

# Install the CVODE implementation header file
INSTALL(FILES cvode_impl.h DESTINATION include/cvode)

#
MESSAGE(STATUS "Added CVODE module")

=== src/ida/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4961 $
# $Date: 2016-09-26 07:58:48 -0700 (Mon, 26 Sep 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the IDA library

INSTALL(CODE "MESSAGE(\"\nInstall IDA\n\")")

# Add variable ida_SOURCES with the sources for the IDA library
SET(ida_SOURCES
  ida.c
  ida_io.c
  ida_ic.c
  ida_direct.c
  ida_band.c
  ida_dense.c
  ida_sparse.c
  ida_spils.c
  ida_spbcgs.c
  ida_spgmr.c
  ida_sptfqmr.c
  ida_bbdpre.c
  )

IF(KLU_FOUND)
    LIST(APPEND ida_SOURCES ida_klu.c)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND ida_SOURCES ida_superlumt.c)
ENDIF()

# IF(PETSC_FOUND)
#    # use MPI_MPICC as the compiler
#    SET(CMAKE_C_COMPILER ${MPI_MPICC})
#    LIST(APPEND ida_SOURCES ida_petsc.c)
# ENDIF()

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the IDA library
SET(shared_SOURCES
  sundials_nvector.c
  sundials_math.c
  sundials_direct.c
  sundials_band.c
  sundials_dense.c
  sundials_iterative.c
  sundials_sparse.c
  sundials_spbcgs.c
  sundials_spgmr.c
  sundials_sptfqmr.c
  )

# Add prefix with complete path to the common SUNDIALS sources
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable ida_HEADERS with the exported IDA header files
SET(ida_HEADERS
  ida_band.h
  ida_bbdpre.h
  ida_dense.h
  ida_direct.h
  ida.h
  ida_spbcgs.h
  ida_spgmr.h
  ida_spils.h
  ida_sptfqmr.h
  )

IF(KLU_FOUND)
    LIST(APPEND ida_HEADERS ida_klu.h ida_sparse.h)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND ida_HEADERS ida_superlumt.h ida_sparse.h)
ENDIF()

# IF(PETSC_FOUND)
#     LIST(APPEND ida_HEADERS ida_petsc.h)
# ENDIF()

# Add prefix with complete path to the IDA header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/ida/ ida_HEADERS)

# If Blas/Lapack support was enabled, set-up additional file lists
IF(LAPACK_FOUND)
  SET(ida_BL_SOURCES ida_lapack.c)
  SET(ida_BL_HEADERS ida_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/ida/ ida_BL_HEADERS)
ELSE(LAPACK_FOUND)
  SET(ida_BL_SOURCES "")
  SET(ida_BL_HEADERS "")
ENDIF(LAPACK_FOUND)

# Add source directories to include directories for access to
# implementation only header files.
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(../sundials)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Build the static library
IF(BUILD_STATIC_LIBS)

  # Add the build target for the static IDA library
  ADD_LIBRARY(sundials_ida_static STATIC 
    ${ida_SOURCES}  ${ida_BL_SOURCES}  ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_ida_static
    PROPERTIES OUTPUT_NAME sundials_ida CLEAN_DIRECT_OUTPUT 1)

  # Install the IDA library
  INSTALL(TARGETS sundials_ida_static DESTINATION lib)

ENDIF(BUILD_STATIC_LIBS)

# Build the shared library
IF(BUILD_SHARED_LIBS)

  # Add the build target for the IDA library
  ADD_LIBRARY(sundials_ida_shared SHARED
    ${ida_SOURCES}  ${ida_BL_SOURCES} ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_ida_shared
    PROPERTIES OUTPUT_NAME sundials_ida CLEAN_DIRECT_OUTPUT 1)

  # Set VERSION and SOVERSION for shared libraries
  SET_TARGET_PROPERTIES(sundials_ida_shared
    PROPERTIES VERSION ${idalib_VERSION} SOVERSION ${idalib_SOVERSION})

  # Install the IDA library
  INSTALL(TARGETS sundials_ida_shared DESTINATION lib)

ENDIF(BUILD_SHARED_LIBS)

# Install the IDA header files
INSTALL(FILES ${ida_HEADERS} ${ida_BL_HEADERS} DESTINATION include/ida)

# Install the IDA implementation header file
INSTALL(FILES ida_impl.h DESTINATION include/ida)

#
MESSAGE(STATUS "Added IDA module")

=== src/idas/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4759 $
# $Date: 2016-05-18 16:25:17 -0700 (Wed, 18 May 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the IDAS library

INSTALL(CODE "MESSAGE(\"\nInstall IDAS\n\")")

# Add variable idas_SOURCES with the sources for the IDAS library
SET(idas_SOURCES
  idas.c
  idaa.c
  idas_io.c
  idas_ic.c
  idaa_io.c
  idas_direct.c
  idas_band.c
  idas_dense.c
  idas_sparse.c
  idas_spils.c
  idas_spbcgs.c
  idas_spgmr.c
  idas_sptfqmr.c
  idas_bbdpre.c
  )

IF(KLU_FOUND)
    LIST(APPEND idas_SOURCES idas_klu.c)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND idas_SOURCES idas_superlumt.c)
ENDIF()

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the IDAS library
SET(shared_SOURCES
  sundials_nvector.c
  sundials_math.c
  sundials_direct.c
  sundials_band.c
  sundials_dense.c
  sundials_iterative.c
  sundials_sparse.c
  sundials_spbcgs.c
  sundials_spgmr.c
  sundials_sptfqmr.c
  )

# Add prefix with complete path to the common SUNDIALS sources
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable idas_HEADERS with the exported IDAS header files
SET(idas_HEADERS
  idas_band.h
  idas_bbdpre.h
  idas_dense.h
  idas_direct.h
  idas.h
  idas_sparse.h
  idas_spbcgs.h
  idas_spgmr.h
  idas_spils.h
  idas_sptfqmr.h
  )

IF(KLU_FOUND)
    LIST(APPEND idas_HEADERS idas_klu.h)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND idas_HEADERS idas_superlumt.h)
ENDIF()

# Add prefix with complete path to the IDAS header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_HEADERS)

# If Blas/Lapack support was enabled, set-up additional file lists
IF(LAPACK_FOUND)
  SET(idas_BL_SOURCES idas_lapack.c)
  SET(idas_BL_HEADERS idas_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_BL_HEADERS)
ELSE(LAPACK_FOUND)
  SET(idas_BL_SOURCES "")
  SET(idas_BL_HEADERS "")
ENDIF(LAPACK_FOUND)

IF(SUPERLUMT_FOUND)
  SET(idas_SLU_SOURCES idas_superlumt.c)
  SET(idas_SLU_HEADERS idas_superlumt.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_SLU_HEADERS)
ELSE(SUPERLUMT_FOUND)
  SET(idas_SLU_SOURCES "")
  SET(idas_SLU_HEADERS "")
ENDIF(SUPERLUMT_FOUND)

# Add source directories to include directories for access to
# implementation only header files.
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(../sundials)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Build the static library
IF(BUILD_STATIC_LIBS)

  # Add the build target for the static IDAS library
  ADD_LIBRARY(sundials_idas_static STATIC 
    ${idas_SOURCES} ${idas_BL_SOURCES} ${idas_SLU_SOURCES}  ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_idas_static
    PROPERTIES OUTPUT_NAME sundials_idas CLEAN_DIRECT_OUTPUT 1)

  # Install the IDA library
  INSTALL(TARGETS sundials_idas_static DESTINATION lib)

ENDIF(BUILD_STATIC_LIBS)

# Build the shared library
IF(BUILD_SHARED_LIBS)

  # Add the build target for the IDAS library
  ADD_LIBRARY(sundials_idas_shared SHARED 
    ${idas_SOURCES}  ${idas_BL_SOURCES} ${idas_SLU_SOURCES} ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_idas_shared
    PROPERTIES OUTPUT_NAME sundials_idas CLEAN_DIRECT_OUTPUT 1)

  # Set VERSION and SOVERSION for shared libraries
  SET_TARGET_PROPERTIES(sundials_idas_shared
    PROPERTIES VERSION ${idaslib_VERSION} SOVERSION ${idaslib_SOVERSION})

  # Install the IDAS library
  INSTALL(TARGETS sundials_idas_shared DESTINATION lib)

ENDIF(BUILD_SHARED_LIBS)

# Install the IDAS header files
INSTALL(FILES ${idas_HEADERS} ${idas_BL_HEADERS} ${idas_SLU_HEADERS} DESTINATION include/idas)

# Install the IDAS implementation header file
INSTALL(FILES idas_impl.h DESTINATION include/idas)

#
MESSAGE(STATUS "Added IDAS module")

=== src/kinsol/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4917 $
# $Date: 2016-09-18 23:24:29 -0700 (Sun, 18 Sep 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the KINSOL library

INSTALL(CODE "MESSAGE(\"\nInstall KINSOL\n\")")

# Add variable kinsol_SOURCES with the sources for the KINSOL library
SET(kinsol_SOURCES
  kinsol.c
  kinsol_io.c
  kinsol_direct.c
  kinsol_band.c
  kinsol_dense.c
  kinsol_sparse.c
  kinsol_spils.c
  kinsol_spbcgs.c
  kinsol_spfgmr.c
  kinsol_spgmr.c
  kinsol_sptfqmr.c
  kinsol_bbdpre.c
  )

IF(KLU_FOUND)
    LIST(APPEND kinsol_SOURCES kinsol_klu.c)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND kinsol_SOURCES kinsol_superlumt.c)
ENDIF()

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the KINSOL library
SET(shared_SOURCES
  sundials_nvector.c
  sundials_math.c
  sundials_direct.c
  sundials_band.c
  sundials_dense.c
  sundials_iterative.c
  sundials_sparse.c
  sundials_spbcgs.c
  sundials_spfgmr.c
  sundials_spgmr.c
  sundials_sptfqmr.c
  )

# Add prefix with complete path to the common SUNDIALS sources
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable kinsol_HEADERS with the exported KINSOL header files
SET(kinsol_HEADERS
  kinsol_band.h
  kinsol_bbdpre.h
  kinsol_dense.h
  kinsol_direct.h
  kinsol.h
  kinsol_spbcgs.h
  kinsol_spfgmr.h
  kinsol_spgmr.h
  kinsol_spils.h
  kinsol_sptfqmr.h
  )

IF(KLU_FOUND)
    LIST(APPEND kinsol_HEADERS kinsol_klu.h kinsol_sparse.h)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND kinsol_HEADERS kinsol_superlumt.h kinsol_sparse.h)
ENDIF()

# Add prefix with complete path to the KINSOL header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/kinsol/ kinsol_HEADERS)

# If Blas/Lapack support was enabled, set-up additional file lists
IF(LAPACK_FOUND)
  SET(kinsol_BL_SOURCES kinsol_lapack.c)
  SET(kinsol_BL_HEADERS kinsol_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/kinsol/ kinsol_BL_HEADERS)
ELSE(LAPACK_FOUND)
  SET(kinsol_BL_SOURCES "")
  SET(kinsol_BL_HEADERS "")
ENDIF(LAPACK_FOUND)

IF(SUPERLUMT_FOUND)
  SET(kinsol_SLU_SOURCES kinsol_superlumt.c)
  SET(kinsol_SLU_HEADERS kinsol_superlumt.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/kinsol/ kinsol_SLU_HEADERS)
ELSE(SUPERLUMT_FOUND)
  SET(kinsol_SLU_SOURCES "")
  SET(kinsol_SLU_HEADERS "")
ENDIF(SUPERLUMT_FOUND)

IF(KLU_FOUND)
  SET(kinsol_KLU_SOURCES kinsol_klu.c)
  SET(kinsol_KLU_HEADERS kinsol_klu.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/kinsol/ kinsol_KLU_HEADERS)
ELSE(KLU_FOUND)
  SET(kinsol_KLU_SOURCES "")
  SET(kinsol_KLU_HEADERS "")
ENDIF(KLU_FOUND)

# Add source directories to include directories for access to
# implementation only header files.
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(../sundials)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Build the static library
IF(BUILD_STATIC_LIBS)

  # Add the build target for the static KINSOL library
  ADD_LIBRARY(sundials_kinsol_static STATIC
    ${kinsol_SOURCES} ${kinsol_BL_SOURCES} ${kinsol_SLU_SOURCES} ${kinsol_KLU_SOURCES} ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_kinsol_static
    PROPERTIES OUTPUT_NAME sundials_kinsol CLEAN_DIRECT_OUTPUT 1)

  # Install the KINSOL library
  INSTALL(TARGETS sundials_kinsol_static DESTINATION lib)

ENDIF(BUILD_STATIC_LIBS)

# Build the shared library
IF(BUILD_SHARED_LIBS)

  # Add the build target for the KINSOL library
  ADD_LIBRARY(sundials_kinsol_shared SHARED
    ${kinsol_SOURCES} ${kinsol_BL_SOURCES} ${kinsol_SLU_SOURCES} ${kinsol_KLU_SOURCES} ${shared_SOURCES})

  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_kinsol_shared
    PROPERTIES OUTPUT_NAME sundials_kinsol CLEAN_DIRECT_OUTPUT 1)

  # Set VERSION and SOVERSION for shared libraries
  SET_TARGET_PROPERTIES(sundials_kinsol_shared
    PROPERTIES VERSION ${kinsollib_VERSION} SOVERSION ${kinsollib_SOVERSION})

  # Install the KINSOL library
  INSTALL(TARGETS sundials_kinsol_shared DESTINATION lib)

ENDIF(BUILD_SHARED_LIBS)

# Install the KINSOL header files
INSTALL(FILES ${kinsol_HEADERS} ${kinsol_BL_HEADERS} ${kinsol_SLU_HEADERS} ${kinsol_KLU_HEADERS} DESTINATION include/kinsol)

# Install the KINSOL implementation header file
INSTALL(FILES kinsol_impl.h DESTINATION include/kinsol)

#
MESSAGE(STATUS "Added KINSOL module")

=== src/nvec_openmp/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4075 $
# $Date: 2014-04-24 10:46:58 -0700 (Thu, 24 Apr 2014) $
# ---------------------------------------------------------------
# Programmer:  Steve Smith @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the openmp NVECTOR library

INSTALL(CODE "MESSAGE(\"\nInstall NVECTOR_OPENMP\n\")")

# Add variable nvecopenmp_SOURCES with the sources for the NVECOPENMP lib
SET(nvecopenmp_SOURCES nvector_openmp.c)

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the NVECOPENMP library
SET(shared_SOURCES sundials_math.c)
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable nvecopenmp_HEADERS with the exported NVECOPENMP header files
SET(nvecopenmp_HEADERS nvector_openmp.h)
ADD_PREFIX(${sundials_SOURCE_DIR}/include/nvector/ nvecopenmp_HEADERS)

# Add source directory to include directories
INCLUDE_DIRECTORIES(.)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

IF(OPENMP_FOUND)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  # Use C flags for linker as well.
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
ENDIF(OPENMP_FOUND)

# Rules for building and installing the static library:
#  - Add the build target for the NVECOPENMP library
#  - Set the library name and make sure it is not deleted
#  - Install the NVECOPENMP library
IF(BUILD_STATIC_LIBS)
  ADD_LIBRARY(sundials_nvecopenmp_static STATIC ${nvecopenmp_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecopenmp_static
    PROPERTIES OUTPUT_NAME sundials_nvecopenmp CLEAN_DIRECT_OUTPUT 1)
  INSTALL(TARGETS sundials_nvecopenmp_static DESTINATION lib)
ENDIF(BUILD_STATIC_LIBS)

# Rules for building and installing the shared library:
#  - Add the build target for the NVECOPENMP library
#  - Set the library name and make sure it is not deleted
#  - Set VERSION and SOVERSION for shared libraries
#  - Install the NVECOPENMP library
IF(BUILD_SHARED_LIBS)
  ADD_LIBRARY(sundials_nvecopenmp_shared SHARED ${nvecopenmp_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecopenmp_shared
    PROPERTIES OUTPUT_NAME sundials_nvecopenmp CLEAN_DIRECT_OUTPUT 1)
  SET_TARGET_PROPERTIES(sundials_nvecopenmp_shared
    PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
  INSTALL(TARGETS sundials_nvecopenmp_shared DESTINATION lib)
ENDIF(BUILD_SHARED_LIBS)

# Install the NVECOPENMP header files
INSTALL(FILES ${nvecopenmp_HEADERS} DESTINATION include/nvector)

# If FCMIX is enabled, build and install the FNVECOPENMP library
IF(FCMIX_ENABLE AND F77_FOUND)
  SET(fnvecopenmp_SOURCES fnvector_openmp.c)
  IF(BUILD_STATIC_LIBS)
    ADD_LIBRARY(sundials_fnvecopenmp_static STATIC ${fnvecopenmp_SOURCES})
    SET_TARGET_PROPERTIES(sundials_fnvecopenmp_static
      PROPERTIES OUTPUT_NAME sundials_fnvecopenmp CLEAN_DIRECT_OUTPUT 1)
    INSTALL(TARGETS sundials_fnvecopenmp_static DESTINATION lib)
  ENDIF(BUILD_STATIC_LIBS)
  IF(BUILD_SHARED_LIBS)
    ADD_LIBRARY(sundials_fnvecopenmp_shared ${fnvecopenmp_SOURCES})
    SET_TARGET_PROPERTIES(sundials_fnvecopenmp_shared
      PROPERTIES OUTPUT_NAME sundials_fnvecopenmp CLEAN_DIRECT_OUTPUT 1)
    SET_TARGET_PROPERTIES(sundials_fnvecopenmp_shared 
      PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
    INSTALL(TARGETS sundials_fnvecopenmp_shared DESTINATION lib)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(FCMIX_ENABLE AND F77_FOUND)

#
MESSAGE(STATUS "Added NVECTOR_OPENMP module")

=== src/nvec_par/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4625 $
# $Date: 2016-01-13 16:05:42 -0800 (Wed, 13 Jan 2016) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the parallel NVECTOR library

INSTALL(CODE "MESSAGE(\"\nInstall NVECTOR_PARALLEL\n\")")

IF(MPI_MPICC)
  # use MPI_MPICC as the compiler
  SET(CMAKE_C_COMPILER ${MPI_MPICC})
ELSE(MPI_MPICC)
  # add MPI_INCLUDE_PATH to include directories
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(MPI_MPICC)

# Add variable nvecparallel_SOURCES with the sources for the NVECPARALLEL lib
SET(nvecparallel_SOURCES nvector_parallel.c)

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the NVECPARALLEL library
SET(shared_SOURCES sundials_math.c)
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable nvecparallel_HEADERS with the exported NVECPARALLEL header files
SET(nvecparallel_HEADERS nvector_parallel.h)
ADD_PREFIX(${sundials_SOURCE_DIR}/include/nvector/ nvecparallel_HEADERS)

# Add source directory to include directories
INCLUDE_DIRECTORIES(.)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Rules for building and installing the static library:
#  - Add the build target for the NVECPARALLEL library
#  - Set the library name and make sure it is not deleted
#  - Install the NVECPARALLEL library
IF(BUILD_STATIC_LIBS)
  ADD_LIBRARY(sundials_nvecparallel_static STATIC ${nvecparallel_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecparallel_static
    PROPERTIES OUTPUT_NAME sundials_nvecparallel CLEAN_DIRECT_OUTPUT 1)
  INSTALL(TARGETS sundials_nvecparallel_static DESTINATION lib)
ENDIF(BUILD_STATIC_LIBS)

# Rules for building and installing the shared library:
#  - Add the build target for the NVECPARALLEL library
#  - Set the library name and make sure it is not deleted
#  - Set VERSION and SOVERSION for shared libraries
#  - Install the NVECPARALLEL library
IF(BUILD_SHARED_LIBS)
  ADD_LIBRARY(sundials_nvecparallel_shared SHARED ${nvecparallel_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecparallel_shared
    PROPERTIES OUTPUT_NAME sundials_nvecparallel CLEAN_DIRECT_OUTPUT 1)
  SET_TARGET_PROPERTIES(sundials_nvecparallel_shared 
    PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
  INSTALL(TARGETS sundials_nvecparallel_shared DESTINATION lib)
ENDIF(BUILD_SHARED_LIBS)

# Install the NVECPARALLEL header files
INSTALL(FILES ${nvecparallel_HEADERS} DESTINATION include/nvector)

# If FCMIX is enabled and MPI-F77 works, build and install the FNVECPARALLEL library
IF(FCMIX_ENABLE AND MPIF_FOUND)
  SET(fnvecparallel_SOURCES fnvector_parallel.c)
  IF(BUILD_STATIC_LIBS)
    ADD_LIBRARY(sundials_fnvecparallel_static STATIC ${fnvecparallel_SOURCES})
    SET_TARGET_PROPERTIES(sundials_fnvecparallel_static
      PROPERTIES OUTPUT_NAME sundials_fnvecparallel CLEAN_DIRECT_OUTPUT 1)
    INSTALL(TARGETS sundials_fnvecparallel_static DESTINATION lib)
  ENDIF(BUILD_STATIC_LIBS)
  IF(BUILD_SHARED_LIBS)
    ADD_LIBRARY(sundials_fnvecparallel_shared SHARED ${fnvecparallel_SOURCES})
    SET_TARGET_PROPERTIES(sundials_fnvecparallel_shared
      PROPERTIES OUTPUT_NAME sundials_fnvecparallel CLEAN_DIRECT_OUTPUT 1)
    SET_TARGET_PROPERTIES(sundials_fnvecparallel_shared
      PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
    INSTALL(TARGETS sundials_fnvecparallel_shared DESTINATION lib)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(FCMIX_ENABLE AND MPIF_FOUND)
#
MESSAGE(STATUS "Added NVECTOR_PARALLEL module")

=== src/nvec_parhyp/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4075 $
# $Date: 2014-04-24 10:46:58 -0700 (Thu, 24 Apr 2014) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the parhyp NVECTOR library

INSTALL(CODE "MESSAGE(\"\nInstall NVECTOR_PARHYP\n\")")

IF(MPI_MPICC)
  # use MPI_MPICC as the compiler
  SET(CMAKE_C_COMPILER ${MPI_MPICC})
ELSE(MPI_MPICC)
  # add MPI_INCLUDE_PATH to include directories
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(MPI_MPICC)

# Add variable nvecparhyp_SOURCES with the sources for the NVECPARHYP lib
SET(nvecparhyp_SOURCES nvector_parhyp.c)

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the NVECPARHYP library
SET(shared_SOURCES sundials_math.c)
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable nvecparhyp_HEADERS with the exported NVECPARHYP header files
SET(nvecparhyp_HEADERS nvector_parhyp.h)
ADD_PREFIX(${sundials_SOURCE_DIR}/include/nvector/ nvecparhyp_HEADERS)

# Add source directory to include directories
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${HYPRE_INCLUDE_DIR})

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Rules for building and installing the static library:
#  - Add the build target for the NVECPARHYP library
#  - Set the library name and make sure it is not deleted
#  - Install the NVECPARHYP library
IF(BUILD_STATIC_LIBS)
  ADD_LIBRARY(sundials_nvecparhyp_static STATIC ${nvecparhyp_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecparhyp_static
    PROPERTIES OUTPUT_NAME sundials_nvecparhyp CLEAN_DIRECT_OUTPUT 1)
  INSTALL(TARGETS sundials_nvecparhyp_static DESTINATION lib)
ENDIF(BUILD_STATIC_LIBS)

# Rules for building and installing the shared library:
#  - Add the build target for the NVECPARHYP library
#  - Set the library name and make sure it is not deleted
#  - Set VERSION and SOVERSION for shared libraries
#  - Install the NVECPARHYP library
IF(BUILD_SHARED_LIBS)
  ADD_LIBRARY(sundials_nvecparhyp_shared SHARED ${nvecparhyp_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecparhyp_shared
    PROPERTIES OUTPUT_NAME sundials_nvecparhyp CLEAN_DIRECT_OUTPUT 1)
  SET_TARGET_PROPERTIES(sundials_nvecparhyp_shared 
    PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
  INSTALL(TARGETS sundials_nvecparhyp_shared DESTINATION lib)
ENDIF(BUILD_SHARED_LIBS)

# Install the NVECPARHYP header files
INSTALL(FILES ${nvecparhyp_HEADERS} DESTINATION include/nvector)

#
MESSAGE(STATUS "Added NVECTOR_PARHYP module")

=== src/nvec_petsc/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision:  $
# $Date:  $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the petsc NVECTOR library

INSTALL(CODE "MESSAGE(\"\nInstall NVECTOR_PETSC\n\")")

IF(MPI_MPICC)
  # use MPI_MPICC as the compiler
  SET(CMAKE_C_COMPILER ${MPI_MPICC})
ELSE(MPI_MPICC)
  # add MPI_INCLUDE_PATH to include directories
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(MPI_MPICC)

# Add variable nvecpetsc_SOURCES with the sources for the NVECPARHYP lib
SET(nvecpetsc_SOURCES nvector_petsc.c)

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the NVECPARHYP library
SET(shared_SOURCES sundials_math.c)
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable nvecpetsc_HEADERS with the exported NVECPARHYP header files
SET(nvecpetsc_HEADERS nvector_petsc.h)
ADD_PREFIX(${sundials_SOURCE_DIR}/include/nvector/ nvecpetsc_HEADERS)

# Add source directory to include directories
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${PETSC_INCLUDE_DIR})

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Rules for building and installing the static library:
#  - Add the build target for the NVECPARHYP library
#  - Set the library name and make sure it is not deleted
#  - Install the NVECPARHYP library
IF(BUILD_STATIC_LIBS)
  ADD_LIBRARY(sundials_nvecpetsc_static STATIC ${nvecpetsc_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecpetsc_static
    PROPERTIES OUTPUT_NAME sundials_nvecpetsc CLEAN_DIRECT_OUTPUT 1)
  INSTALL(TARGETS sundials_nvecpetsc_static DESTINATION lib)
ENDIF(BUILD_STATIC_LIBS)

# Rules for building and installing the shared library:
#  - Add the build target for the NVECPARHYP library
#  - Set the library name and make sure it is not deleted
#  - Set VERSION and SOVERSION for shared libraries
#  - Install the NVECPARHYP library
IF(BUILD_SHARED_LIBS)
  ADD_LIBRARY(sundials_nvecpetsc_shared SHARED ${nvecpetsc_SOURCES} ${shared_SOURCES})
  SET_TARGET_PROPERTIES(sundials_nvecpetsc_shared
    PROPERTIES OUTPUT_NAME sundials_nvecpetsc CLEAN_DIRECT_OUTPUT 1)
  SET_TARGET_PROPERTIES(sundials_nvecpetsc_shared 
    PROPERTIES VERSION ${nveclib_VERSION} SOVERSION ${nveclib_SOVERSION})
  INSTALL(TARGETS sundials_nvecpetsc_shared DESTINATION lib)
ENDIF(BUILD_SHARED_LIBS)

# Install the NVECPARHYP header files
INSTALL(FILES ${nvecpetsc_HEADERS} DESTINATION include/nvector)

#
MESSAGE(STATUS "Added NVECTOR_PETSC module")

=== src/sundials/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4075 $
# $Date: 2014-04-24 10:46:58 -0700 (Thu, 24 Apr 2014) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the generic SUNDIALS modules

# From here we only install the generic SUNDIALS headers. 
# The implementations themselves are incorporated in the individual SUNDIALS solver libraries.

INSTALL(CODE "MESSAGE(\"\nInstall shared components\n\")")

# Add variable sundials_HEADERS with the exported SUNDIALS header files
SET(sundials_HEADERS
  sundials_band.h
  sundials_dense.h
  sundials_direct.h
  sundials_iterative.h
  sundials_math.h
  sundials_nvector.h
  sundials_fnvector.h
  sundials_pcg.h
  sundials_sparse.h
  sundials_spbcgs.h
  sundials_spfgmr.h
  sundials_spgmr.h
  sundials_sptfqmr.h
  sundials_types.h
  )

# Add prefix with complete path to the SUNDIALS header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/sundials/ sundials_HEADERS)

# Install the SUNDIALS header files
INSTALL(FILES ${sundials_HEADERS} DESTINATION include/sundials)

# If Blas/Lapack support was enabled, install the Lapack interface headers
IF(LAPACK_FOUND)
  SET(sundials_BL_HEADERS sundials_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/sundials/ sundials_BL_HEADERS)
  INSTALL(FILES ${sundials_BL_HEADERS} DESTINATION include/sundials)
ENDIF(LAPACK_FOUND)

=== examples/arkode/CXX_parallel/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# LLNS/SMU Copyright Start
# Copyright (c) 2015, Southern Methodist University and 
# Lawrence Livermore National Security
#
# This work was performed under the auspices of the U.S. Department 
# of Energy by Southern Methodist University and Lawrence Livermore 
# National Laboratory under Contract DE-AC52-07NA27344.
# Produced at Southern Methodist University and the Lawrence 
# Livermore National Laboratory.
#
# All rights reserved.
# For details, see the LICENSE file.
# LLNS/SMU Copyright End
# Copyright (c) 2013, Southern Methodist University.
# All rights reserved.
# For details, see the LICENSE file.
# -----------------------------------------------------------------
# CMakeLists.txt file for ARKODE C++ parallel examples


# Add variable ARKODE_examples with the names of the parallel ARKODE examples

SET(ARKODE_examples
  ark_heat2D
  )

# Add variable ARKODE_extras with the names of auxiliary files to install

SET(ARKODE_extras
  plot_heat2D.py
  )

# Check whether we use MPI compiler scripts.
# If yes, then change the C compiler to the MPICC script.
# If not, then add the MPI include directory for MPI headers.

IF(MPI_MPICXX)
  # use MPI_MPICXX as the compiler
  SET(CMAKE_CXX_COMPILER ${MPI_MPICXX})
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -DLAM_BUILDING")
ELSE(MPI_MPICXX)
  # add MPI_INCLUDE_PATH to include directories
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(MPI_MPICXX)

# Specify libraries to link against (through the target that was used to 
# generate them) based on the value of the variable LINK_LIBRARY_TYPE

IF(LINK_LIBRARY_TYPE MATCHES "static")
  SET(ARKODE_LIB sundials_arkode_static)
  SET(NVECP_LIB sundials_nvecparallel_static)
ELSE(LINK_LIBRARY_TYPE MATCHES "static")
  SET(ARKODE_LIB sundials_arkode_shared)
  SET(NVECP_LIB sundials_nvecparallel_shared)
ENDIF(LINK_LIBRARY_TYPE MATCHES "static")

# Set-up linker flags and link libraries

SET(SUNDIALS_LIBS ${ARKODE_LIB} ${NVECP_LIB} ${EXTRA_LINK_LIBS})
IF(LAPACK_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${LAPACK_LIBRARIES})
ENDIF(LAPACK_FOUND)

IF(KLU_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${KLU_LIBRARIES})
ENDIF(KLU_FOUND)

IF(SUPERLUMT_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${SUPERLUMT_LIBRARIES})
ENDIF(SUPERLUMT_FOUND)

# Add the build and install targets for each ARKODE example

FOREACH(example ${ARKODE_examples})
  ADD_EXECUTABLE(${example} ${example}.cpp)
  SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")
  SUNDIALS_ADD_TEST(${example} ${example})
  TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS})
  IF(NOT MPI_MPICXX)
    TARGET_LINK_LIBRARIES(${example} ${MPI_LIBRARY} ${MPI_EXTRA_LIBRARIES})
  ENDIF(NOT MPI_MPICXX)
  IF(EXAMPLES_INSTALL)
    INSTALL(FILES ${example}.cpp ${example}.out DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_parallel)
  ENDIF(EXAMPLES_INSTALL)
ENDFOREACH(example ${ARKODE_examples})

IF(EXAMPLES_INSTALL)

  # Install the README file
  INSTALL(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_parallel)

  # Install the extra files
  FOREACH(extrafile ${ARKODE_extras})
    INSTALL(FILES ${extrafile} DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_parallel)
  ENDFOREACH(extrafile ${ARKODE_extras})

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  SET(SOLVER "ARKODE")
  SET(SOLVER_LIB "sundials_arkode")
  LIST2STRING(ARKODE_examples EXAMPLES)

  # Regardless of the platform we're on, we will generate and install 
  # CMakeLists.txt file for building the examples. This file  can then 
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_parallel_CXX_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/CXX_parallel/CMakeLists.txt
      @ONLY
      )

  # install CMakelists.txt
  INSTALL(
    FILES ${PROJECT_BINARY_DIR}/examples/arkode/CXX_parallel/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_parallel 
    )

  # On UNIX-type platforms, we also  generate and install a makefile for 
  # building the examples. This makefile can then be used as a template 
  # for the user's own programs.

  IF(UNIX)
    # generate Makefile and place it in the binary dir
    CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_parallel_CXX_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/CXX_parallel/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    INSTALL(
      FILES ${PROJECT_BINARY_DIR}/examples/arkode/CXX_parallel/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_parallel
      RENAME Makefile
      )
  ENDIF(UNIX)

ENDIF(EXAMPLES_INSTALL)

=== examples/arkode/CXX_serial/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# LLNS/SMU Copyright Start
# Copyright (c) 2015, Southern Methodist University and 
# Lawrence Livermore National Security
#
# This work was performed under the auspices of the U.S. Department 
# of Energy by Southern Methodist University and Lawrence Livermore 
# National Laboratory under Contract DE-AC52-07NA27344.
# Produced at Southern Methodist University and the Lawrence 
# Livermore National Laboratory.
#
# All rights reserved.
# For details, see the LICENSE file.
# LLNS/SMU Copyright End
# Copyright (c) 2013, Southern Methodist University.
# All rights reserved.
# For details, see the LICENSE file.
# -----------------------------------------------------------------
# CMakeLists.txt file for ARKODE serial examples

# Add variable ARKODE_examples with the names of the serial ARKODE examples

SET(ARKODE_examples
  ark_analytic_sys
  )

# Add variable ARKODE_examples_BL with the names of the serial ARKODE examples
# that use Lapack

SET(ARKODE_examples_BL
  )

# Add variable ARKODE_extras with the names of auxiliary files to install

SET(ARKODE_extras
  plot_sol.py
  )

# Specify libraries to link against (through the target that was used to 
# generate them) based on the value of the variable LINK_LIBRARY_TYPE

IF(LINK_LIBRARY_TYPE MATCHES "static")
  SET(ARKODE_LIB sundials_arkode_static)
  SET(NVECS_LIB sundials_nvecserial_static)
ELSE(LINK_LIBRARY_TYPE MATCHES "static")
  SET(ARKODE_LIB sundials_arkode_shared)
  SET(NVECS_LIB sundials_nvecserial_shared)
ENDIF(LINK_LIBRARY_TYPE MATCHES "static")

# Set-up linker flags and link libraries

SET(SUNDIALS_LIBS ${ARKODE_LIB} ${NVECS_LIB} ${EXTRA_LINK_LIBS})
IF(LAPACK_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${LAPACK_LIBRARIES})
ENDIF(LAPACK_FOUND)

IF(KLU_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${KLU_LIBRARIES})
ENDIF(KLU_FOUND)

IF(SUPERLUMT_FOUND)
  LIST(APPEND SUNDIALS_LIBS ${SUPERLUMT_LIBRARIES})
ENDIF(SUPERLUMT_FOUND)

# Add the build and install targets for each ARKODE example

FOREACH(example ${ARKODE_examples})
  ADD_EXECUTABLE(${example} ${example}.cpp)
  SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")
  SUNDIALS_ADD_TEST(${example} ${example})
  TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS})
  IF(EXAMPLES_INSTALL)
    INSTALL(FILES ${example}.cpp ${example}.out DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial)
  ENDIF(EXAMPLES_INSTALL)
ENDFOREACH(example ${ARKODE_examples})

# Add the build and install targets for each Lapack ARKODE example (if needed)

IF(LAPACK_FOUND)
  FOREACH(example ${ARKODE_examples_BL})
    ADD_EXECUTABLE(${example} ${example}.cpp)
    SET_TARGET_PROPERTIES(${example} PROPERTIES FOLDER "Examples")
    SUNDIALS_ADD_TEST(${example} ${example})
    TARGET_LINK_LIBRARIES(${example} ${SUNDIALS_LIBS})
    IF(EXAMPLES_INSTALL)
      INSTALL(FILES ${example}.cpp ${example}.out DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial)
    ENDIF(EXAMPLES_INSTALL)
  ENDFOREACH(example ${ARKODE_examples_BL})
ENDIF(LAPACK_FOUND)

IF(EXAMPLES_INSTALL)

  # Install the README file
  INSTALL(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial)

  # Install the extra files
  FOREACH(extrafile ${ARKODE_extras})
    INSTALL(FILES ${extrafile} DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial)
  ENDFOREACH(extrafile ${ARKODE_extras})

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  SET(SOLVER "ARKODE")
  SET(SOLVER_LIB "sundials_arkode")
  LIST2STRING(ARKODE_examples EXAMPLES)
  IF(LAPACK_FOUND)
    LIST2STRING(ARKODE_examples_BL EXAMPLES_BL)
  ELSE(LAPACK_FOUND)
    SET(EXAMPLES_BL "")
  ENDIF(LAPACK_FOUND)

  # Regardless of the platform we're on, we will generate and install 
  # CMakeLists.txt file for building the examples. This file  can then 
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_serial_CXX_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/CXX_serial/CMakeLists.txt
      @ONLY
      )

  # install CMakelists.txt
  INSTALL(
    FILES ${PROJECT_BINARY_DIR}/examples/arkode/CXX_serial/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial 
    )

  # On UNIX-type platforms, we also  generate and install a makefile for 
  # building the examples. This makefile can then be used as a template 
  # for the user's own programs.

  IF(UNIX)
    # generate Makefile and place it in the binary dir
    CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_serial_CXX_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/CXX_serial/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    INSTALL(
      FILES ${PROJECT_BINARY_DIR}/examples/arkode/CXX_serial/Makefile_ex 
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/CXX_serial 
      RENAME Makefile
      )
  ENDIF(UNIX)

ENDIF(EXAMPLES_INSTALL)

=== debian/changelog ===
sundials (2.7.0+dfsg-2build1) bionic; urgency=medium

  * Rebuild against new hypre 2.13.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 12 Dec 2017 12:17:13 +0100

sundials (2.7.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Look for KLU library into the right multiarch directory.
    Fixes FTBFS on any-i386.
  * Bump Standards-Version to 4.1.0.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 28 Aug 2017 18:22:01 +0200

sundials (2.7.0+dfsg-1) experimental; urgency=medium

  * Team upload.

  [ Dima Kogan ]
  * New upstream release (Closes: #798331, #809072)
    - Upstream dropped octave support, so the "octave-sundials" package is
      gone
  * Package reorganized: all documentation, dev files into new
    "libsundials-dev" package
  * All examples are shipped and are buildable and runnable in "libsundials-dev"
  * All parallelization options shipped in the various packages:
    - libsundials-nvecparallel-hypre2
    - libsundials-nvecparallel-mpi2
    - libsundials-nvecparallel-openmp2
    - libsundials-nvecparallel-petsc2
    - libsundials-nvecparallel-pthread2
  * Package repo moved to git

  [ Andreas Tille ]
  * Build hardening=+bindnow
  * Set Dima Kogan and James Tocknell as Uploaders
  * Reorganized debian/copyright: it now conforms to the dep5 standard
  * Updated to debhelper 10
  * Fixed watch file: it works now
  * Fix Vcs fields

  [ James Tocknell ]
  * Improve PETSc support
  * Update BLAS/LAPACK deps to correct metapackages

  [ Sylvestre Ledru ]
  * Removed Sylvestre Ledru from the uploaders

  [ Sébastien Villemot ]
  * Bump Standards-Version to 4.0.1.

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 18 Aug 2017 11:44:19 +0200

sundials (2.5.0-3) unstable; urgency=low

  * Team upload.
  * Revert changes from experimental version which inadvertently made it into
    the previous upload.
  * Improve the fix for missing BLAS and LAPACK dependencies (closes: #700525)
    + no longer pass BLAS and LAPACK through LDFLAGS
    + link-blas-lapack.patch: new patch which rather adds the dependencies at
      the libtool link level
    + add missing dependency of libsundials-serial-dev on libblas-dev and
      liblapack-dev
  * Fix the dependency of octave-sundials on octave.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Feb 2013 16:58:32 +0100

sundials (2.5.0-2) unstable; urgency=low

  * debian/rules:
      - Add -lblas -llapack -lm to LDFLAGS (closes: #700525)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Thu, 14 Feb 2013 16:58:48 +0100

sundials (2.5.0-2~exp1) experimental; urgency=low

  [ Andrew Miller ]
  * Fix spelling of suite (closes: #680881)
  * Add a -dbg package (closes: #680878)

  [ Rafael Laboissiere ]
  * debian/rules:
      - Install .mex files in the appropriate directory

  * Switch to buildsystem to cmake
  * Switch to debhelper 9
  * Switch to dpkg-source 3.0 (quilt) format

  * Add support for parallel version
  * Add a separate package for examples
  * Modify check.sh to run serial tests

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 9 Jul 2012 09:40:03 +1200

sundials (2.5.0-1) unstable; urgency=low

  * New upstream release
  * Remove sh4.patch
  * Standards-Version changed to 3.9.3

  [Kamaraju Kusumanchi][Rafael Laboissiere]
  * Adjust for the new octave package version 3.6.1 (closes: #668830)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Tue, 24 Apr 2012 08:49:39 +0200

sundials (2.4.0-6) unstable; urgency=low

  * Rebuild using the last version of hdf5.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 26 Jan 2012 10:18:07 +0100

sundials (2.4.0-5) unstable; urgency=low

  * debian/rules: remove duplicate definition of debexp var.
    This brings back the missing static libraries (closes: #650933)
  * debian/control: add DM-Upload-Allowed

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 05 Dec 2011 08:36:33 +0100

sundials (2.4.0-4) unstable; urgency=low

  * add octave support
  
  [Peter Green]
  * debian/patches: add fix-format-error.patch (Closes: #646457)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 24 Oct 2011 15:01:41 +0200

sundials (2.4.0-3) unstable; urgency=low

  * Change the uploader to Debian Science
  * Standards-Version changed to 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 08 Aug 2011 22:29:34 +0200

sundials (2.4.0-2) unstable; urgency=low

  [Nobuhiro Iwamatsu]
  * debian/patches: add sh4.patch (Closes: #602160)

 -- Christophe Trophime <christophe.trophime@grenoble.cnrs.fr>  Mon, 14 Feb 2011 11:25:18 +0100

sundials (2.4.0-1) unstable; urgency=low

  * Standards-Version changed to 3.9.1

  [ Christophe Trophime ]
  * Team upload
  * New upstream version
  * Add a separate package for IDAS
  * Remove pdf from the orig tarball
  * debian/control:  add missing builddependencies on blas/lapack
  * debian/control: remove libsundials-serial-doc
  * debian/rules: modify get-orig-rules target to remove pdf from the orig
    tarball
  * debian/orig-tarball.sh: change to force download to tarballs directory
	
 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Oct 2010 18:18:22 +0200

sundials (2.3.0-2) unstable; urgency=low

  * Package moved to debian-science
  * Raphael removed and add myself in the Uploaders list (Closes: #571898)
  * Missing replace/conflicts added (Closes: #540498)
  * No longer install *.la files
  * bashim removed (Closes: #530983)
  * Standards-Version updated to version 3.8.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Mar 2010 22:54:48 +0200

sundials (2.3.0-1) unstable; urgency=low

  [ Andrey Romanenko ]
  * New upstream release
  * Added sundials-config man page

  [ Rafael Laboissiere ]
  * Switch from CDBS' simple-patchsys to quilt
  * Split the libsundials-serial package into individual library packages
  * debian/clean: Add file for removing config.log (Lintian warning) and the


=== debian/control ===
Source: sundials
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               pkg-config,
               chrpath,
               cmake,
               python,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev, libsuitesparse-dev, libhypre-dev
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/sundials.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/sundials.git
Homepage: http://www.llnl.gov/CASC/sundials/

Package: libsundials-arkode1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode1              (= ${binary:Version}),
         libsundials-cvode2               (= ${binary:Version}),
         libsundials-cvodes2              (= ${binary:Version}),
         libsundials-ida2                 (= ${binary:Version}),
         libsundials-idas1                (= ${binary:Version}),
         libsundials-kinsol2              (= ${binary:Version}),
         libsundials-nvecserial2          (= ${binary:Version}),
         libsundials-nvecparallel-mpi2    (= ${binary:Version}),
         libsundials-nvecparallel-pthread2(= ${binary:Version}),
         libsundials-nvecparallel-openmp2 (= ${binary:Version}),
         libsundials-nvecparallel-hypre2  (= ${binary:Version}),
         libsundials-nvecparallel-petsc2  (= ${binary:Version}),
         cmake, mpi-default-dev, libhypre-dev, petsc-dev, gfortran, pkg-config,
         ${misc:Depends}
Breaks: libsundials-serial-dev
Replaces: libsundials-serial-dev
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.

=== debian/rules ===
#!/usr/bin/make -f

#workaround to start MPI-applications in chroot
export OMPI_MCA_plm_rsh_agent=/bin/false

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

extra_flags +=						\
   -DCMAKE_Fortran_COMPILER=gfortran			\
   -DBUILD_SHARED_LIBS:BOOL=ON				\
   -DBUILD_STATIC_LIBS:BOOL=ON				\
   -DFCMIX_ENABLE:BOOL=ON				\
   -DMPI_ENABLE:BOOL=ON					\
   -DLAPACK_ENABLE:BOOL=ON				\
							\
   -DEXAMPLES_ENABLE:BOOL=OFF				\
   -DEXAMPLES_INSTALL:BOOL=OFF				\
							\
   -DOPENMP_ENABLE:BOOL=ON				\
   -DPTHREAD_ENABLE:BOOL=ON				\
                                                        \
   -DKLU_ENABLE:BOOL=ON					\
   -DKLU_INCLUDE_DIR=/usr/include/suitesparse		\
   -DKLU_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)	\
                                                        \
   -DPETSC_ENABLE:BOOL=ON				\
                                                        \
   -DSUPERLUMT_ENABLE:BOOL=OFF				\
                                                        \
   -DHYPRE_ENABLE:BOOL=ON                               \
   -DHYPRE_INCLUDE_DIR=/usr/include/hypre               \
   -DHYPRE_LIBRARY='-lHYPRE -lHYPRE_IJ_mv -lHYPRE_utilities -lHYPRE_parcsr_mv -lHYPRE_seq_mv'

BUILDDIR = $(CURDIR)/debian/build


%:
	dh $@ --buildsystem=cmake  --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_auto_install:
	dh_auto_install
# I strip out all the RPATH/RUNPATH tags from my shared objects. These all point
# to libraries that actually live in standard locations, so the tags are not
# needed
	find debian/tmp/ -name '*.so' -o -name '*.so.*' -exec chrpath -d '{}' \;

#
#to generate symbols
#	dpkg-gensymbols -plibsundials-parallel -O

override_dh_compress:
	dh_compress -Xexamples/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
